import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

public class ColorChooserPanel extends JPanel {
	private JSlider redSlider, blueSlider, greenSlider;
	private JTextField redTextField, blueTextField, greenTextField;
	private JLabel redLabel, blueLabel, greenLabel;
	private Color color;
	
	public ColorChooserPanel() {
	
		redLabel = new JLabel( "Red:" );
		redSlider = new JSlider( SwingConstants.HORIZONTAL, 0, 255, 0 );
		redTextField = new JTextField( "0", 4 );
		redTextField.setEditable( false );
		
		greenLabel = new JLabel( "Green:" );
		greenSlider = new JSlider( SwingConstants.HORIZONTAL, 0, 255, 0 );
		greenTextField = new JTextField( "0", 4 );
		greenTextField.setEditable( false );
		
		blueLabel = new JLabel( "Blue:" );
		blueSlider = new JSlider( SwingConstants.HORIZONTAL, 0, 255, 0 );
		blueTextField = new JTextField( "0", 4 );
		blueTextField.setEditable( false );
		
		setLayout( new GridLayout( 3, 3 ) );
		
		add( redLabel );
		add( redSlider );
		add( redTextField );
		add( greenLabel );
		add( greenSlider );
		add( greenTextField );
		add( blueLabel );
		add( blueSlider );
		add( blueTextField );
		
		redSlider.addChangeListener( new ChangeHandler() );
		greenSlider.addChangeListener( new ChangeHandler() );
		blueSlider.addChangeListener( new ChangeHandler() );
		color = Color.black;
	}
	
	public Color getColor() {
		return color;
	}
	
	public JSlider getRedSlider() {
		return redSlider;
	}
	
	public JSlider getGreenSlider() {
		return greenSlider;
	}
	
	public JSlider getBlueSlider() {
		return blueSlider;
	}
	
	private class ChangeHandler implements ChangeListener {
	
		public void stateChanged( ChangeEvent e ) {
			int red = redSlider.getValue();
			int green = greenSlider.getValue();
			int blue = blueSlider.getValue();
			
			color = new Color( red, green, blue );
			
			redTextField.setText( String.valueOf( red ) );
			greenTextField.setText( String.valueOf( green ) );
			blueTextField.setText( String.valueOf( blue ) );
		}
		
	}
	
}